//
//  gesturerStudy.swift
//  Swift_Study
//
//  Created by 🐷 on 16/4/26.
//  Copyright © 2016年 🐷. All rights reserved.
//

import UIKit

class gesturerStudy: UIViewController ,UIGestureRecognizerDelegate {

    // 底View
    var redView = UIView(frame:CGRect(x: 50, y: 85, width: 100, height: 100));
    
    // blueView
    var blueView = UIView();
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        
//        redView = UIView(frame:);
        
        redView.backgroundColor = UIColor.redColor();
        
        blueView.backgroundColor = UIColor.blueColor();
        
        self.view.addSubview(redView);
        
        
        let  tapGestures = UITapGestureRecognizer(target: self,action:#selector(gesturerStudy.tapAction(_:)));
        // 单击
        tapGestures.numberOfTapsRequired = 1;
        tapGestures.numberOfTouchesRequired = 1;
        tapGestures.delegate = self;
        
        redView.addGestureRecognizer(tapGestures);
        
        
        
        // 滑动手势
        let swipGesture = UISwipeGestureRecognizer(target: self,action: #selector(gesturerStudy.swipAction(_:)))
        
        swipGesture.delegate = self;
        // 设置滑动方向
        swipGesture.direction = UISwipeGestureRecognizerDirection.Right;
        
        redView.addGestureRecognizer(swipGesture)
        
        //长按手势
        let longpressGesutre = UILongPressGestureRecognizer(target: self, action: #selector(gesturerStudy.handleLongpressGesture(_:)))
        //长按时间为1秒
        longpressGesutre.minimumPressDuration = 1
        //允许15秒运动
        longpressGesutre.allowableMovement = 15
        //所需触摸1次
        longpressGesutre.numberOfTouchesRequired = 1
        self.view.addGestureRecognizer(longpressGesutre)
        
        
        // 拖动手势
        let panGes = UIPanGestureRecognizer(target: self,action: #selector(gesturerStudy.panGesAction(_:)))
        
        panGes.delegate = self;
        
        self.view.addGestureRecognizer(panGes)
        
        // 缩放手势
        let gesture = UIPinchGestureRecognizer(target: self, action: #selector(gesturerStudy.viewPinch(_:)))
        
        self.redView.addGestureRecognizer(gesture)
        
        
        // 旋转手势
        let roteGes = UIRotationGestureRecognizer(target: self, action: #selector(gesturerStudy.viewRotation(_:)))
       
        self.redView.addGestureRecognizer(roteGes)
        
        // 自定义手势
        let customGes = CustomGestureRecognizer(target: self, action: #selector(gesturerStudy.viewCustom(_:)))
        
        self.redView.addGestureRecognizer(customGes)
        
        
    }
    
    // 自定义手势处理
    func viewCustom(sender: CustomGestureRecognizer) {
        print(" 需要的处理 逻辑")
    }
    
    /**旋转事件*/
    func viewRotation(sender: UIRotationGestureRecognizer) {
        self.redView.transform = CGAffineTransformMakeRotation(sender.rotation)
    }
    
    
    func viewPinch(sender: UIPinchGestureRecognizer) {

        let _width = self.redView.bounds.width
        let _height = self.redView.bounds.height
        self.redView.bounds.size = CGSize(width: _width * sender.scale, height: _height * sender.scale)
    }

    
    // 拖动手势
    
    func panGesAction(sender:UIPanGestureRecognizer) {
        let _transX = sender.translationInView(self.redView).x
        let _transY = sender.translationInView(self.redView).y
        
        self.redView.transform = CGAffineTransformMakeTranslation(_transX, _transY)
        
    }
    
    //长按手势
    func handleLongpressGesture(sender : UILongPressGestureRecognizer){
        
        if sender.state == UIGestureRecognizerState.Began{
            //创建警告
            print("长按");
        }
    }
    
    
    func tapAction(tap:UITapGestureRecognizer){
        
      print("单击手势")
    }

    func swipAction(swip:UISwipeGestureRecognizer){
    
        print("滑动手势")
    
    }
    
}
